using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

using XNACS1Lib;

namespace SimpleXNA
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : XNACS1Base
    {
        XNACS1Circle circle;    // The circle

        protected override void InitializeWorld()
        {
            World.SetWorldCoordinate(new Vector2(0f, 0f), 15f);   // Define the world coordinate
            circle = new XNACS1Circle(new Vector2(5f, 5f),  // center
                                        1.0f);              // radius
        }

        protected override void UpdateWorld()
        {
            // Allows the game to exit
            if (GamePad.ButtonBackClicked())
                this.Exit();
            
            circle.Center += GamePad.ThumbSticks.Left;
            EchoToBottomStatus("Circle drawn at: " + circle.Center);
            EchoToTopStatus("i-up m-down j-left k-right");
        }
    }
}
