using System;

namespace MonteCarloSolution
{
    class MonteCarloIntegrator
    {
        public void RunProgram()
        {
            // Students:
            // Replace the following with your own code
            // Be aware that one of the goals for this assignment
            // is for you to take the overall problem, and break it down
            // into smaller methods (functions) that each have a single, useful
            // purpose - this is sometimes called 'functional decomposition'
            // 
            // So keep that in mind as you work on your solution to this problem!
            trivialExampleMethod();
            trivialExampleMethod();

            // STUDENTS: READ THE BELOW INFORNATION !!!!!

            // At this point, you need to think about how to create your solution program,
            // including the requirement that you use at least one array, and that you
            // use several functions/methods, in order to make your code more modular
            //
            //
            // Here in runProgram, you might think about setting up any 'overall/configuration'
            // that you need to.  For example, you might find a way to store how many darts to throw
            // (points to pick) for each time you try to do the Monte Carlo Integration.
            // For example -if you were going to test the Monte Carlo Integration with 10 points, then
            //      100 points, then 10,000 points, it would be good store 10, 100, and 10,000 someplace...
            //
            // It would be great if you could use a loop to get those numbers back out of whereever
            //  you stored them, since you could then use that loop to repeatedly
            //  1) get the next number (10 the first time, 100 the second, 10,000 the third)
            //  2) feed that number (and any other info, like the size of the 'page', the location & size of
            //          the circle, etc) to a function/subroutine that will actually do all the
            //          work of the Monte Carlo Integration
            //
            //  Within that function (the one that actually does the integration), you should look for
            //      ways to subdivide the logic into other methods/functions.  
            //      a) One reason to create another method is if you plan on using that logic 
            //          several times, in different locations within your code.
            //      b) Another reason is to make it easier to understand what the integration function
            //          is doing.  When you take some of your integration logic, and put it into another
            //          method, you'll have to give that method a name.  Back in the integration logic,
            //          things will be easier to understand because you've replaced a bunch of lines of
            //          code with a concise, descriptive name for what you're trying to do.

            // STUDENTS: READ THE ABOVE INFORNATION !!!!!
        }

        private void trivialExampleMethod()
        {
            Console.WriteLine("Hello, World!");
        }
    }
}
