using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using XNACS1Lib;


namespace InsectsGarden_Program
{
    class InsectCollection
    {
        private const float CLOSE_TO_NET = 1.8f;
        private const int FIRST_FIVE_SCORES = 10;
        
        private InsectsGarden m_Garden;

        // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:
        

        // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

        public InsectCollection(InsectsGarden garden)
        {

            m_Garden = garden;

            // STUDENTS: YOU (MAY) NEED TO WRITE YOUR CODE BELOW:


            // STUDENTS: YOU (MAY) NEED TO WRITE YOUR CODE ABOVE:

        }

        /// <summary>
        /// This function is called (by the Garden) when a new insect is "spotted". 
        /// You generate a random position between
        /// 
        ///     0 to m_Garden.GardenWidth
        ///     0 to m_Garden.GardenHeight
        /// 
        /// and call the m_Garden.CreateInsectAt(x, y).
        /// </summary>
        /// <returns> a Vector2 </returns>
        public void PlaceANewInsect()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            // In order to let the rest of the game know where to create the new
            // insect, you'll need to call the 'CreateInsectAt' command.  If you wanted to 
            // create the new insect at the location of (20, 50) (so the X value of the
            // coordinate is 20 (meaning that the insect is 20 units of distance rightwards from
            // the left edge of the window), and the y is 50 (meaning that the insect is 
            // 50 units of distance down from the top edge of the window), you would do so
            // using the following command:
            //
            // m_Garden.CreateInsectAt(20.0, 50.0); // (Obviously, you need to un-comment this :)  )
            //
            // (Also remember that you can pass in variables, so if x is a variable with the value
            // 20.0,and y has the value 50.0, the following will do the same thing as the above example:
            //
            // m_Garden.CreateInsectAt(x, y); // (Obviously, you need to un-comment this :)  )
            //

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        /// <summary>
        /// This function will be called, and will determine if the player's net is
        /// touching the insect. You can assume if the two points are less than CLOST_TO_NET distance
        /// away then it is considered as "caught".
        /// </summary>
        /// <param name="insectX"> insect's X position </param>
        /// <param name="insectY"> insect's Y position </param>
        /// <param name="netX"> the net'x current X position </param>
        /// <param name="netY"> the net's current Y position </param>
        /// <param name="score"> the score for catching this insect </param>
        /// <returns></returns>
        public bool CatchInsect(double insectX, double insectY, double netX, double netY, int score)
        {
            double dx = insectX - netX;
            double dy = insectY - netY;
            double dist = Math.Sqrt((dx*dx) + (dy*dy));
            bool caught = (dist < CLOSE_TO_NET);

            if (caught)
            {
                // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

                // You will need to examine the 'score' parameter (described above)
                // in order to fully complete this assignment

                // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
            }

            return caught;
        }

        public String InsectsStatus()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:
            // (You will want to replace this code that is being provided to you:)
            
            string myString = "Here is the first part";
            myString = myString + ", the second,";
            myString += " and the third";

            return myString;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }
    }
}
