#define INSTRUCTOR_VERSION
// #define STUDENT_VERSION

using System;

namespace StarterFiles
{
    class Element
    {
        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////

        private int m_atomicNumber;
        private string m_name;
        private string m_symbol;
        private double m_weight;

#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////

        public Element(int num, string name, string sym, double w)
        {
            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////
            m_atomicNumber = num;
            m_name = name;
            m_symbol = sym;
            m_weight = w;
#endif      ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////

            // STUDENTS - IMPLEMENT THIS!!
        }


        // HINT: In terms of figuring out what's a transition metal, etc,
        // you should do a web search for 'Periodic table', and then see what
        // useful,scientifically relevant images you find.  Your instructor can help you
        // if you get stuck - keep in mind that while you may (or may not) find the 
        // programming-related aspects of this assignment challenging, you shouldn't be spending
        // much time on the chemistry-specific stuff.  So if you're confused about the chemistry,
        // ask!!
        public void Print()
        {
            // STUDENTS - IMPLEMENT THIS!!

            ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////////

            Console.Write("Atomic #:{0}\n\tName:{1}\n\tSymbol:{2}\n\tAtomic Weight:{3}",
                m_atomicNumber, m_name, m_symbol, m_weight);

            if (m_atomicNumber >= 21 && m_atomicNumber <= 30 ||
                m_atomicNumber >= 39 && m_atomicNumber <= 48 ||
                m_atomicNumber >= 72 && m_atomicNumber <= 80 ||
                m_atomicNumber >= 104 && m_atomicNumber <= 110)
            {
                Console.WriteLine("\n\tThis element is a TRANSITION METAL");
            }
            else if (m_atomicNumber >= 57 && m_atomicNumber <= 71 ||
                m_atomicNumber >= 89 && m_atomicNumber <= 103)
            {
                Console.Write("\n\tThis element is an INNER TRANSITION METAL (aka RARE EARTH METAL)");
                if (m_atomicNumber >= 57 && m_atomicNumber <= 71)
                    Console.WriteLine("\n\tThis element is a LANTHANIDE");
                else if (m_atomicNumber >= 89 && m_atomicNumber <= 103)
                    Console.WriteLine("\n\tThis element is an ACTINIDE");
            }
            else
                Console.WriteLine(); // otherwise things don't quite line up..

#endif      ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
            ///////////////////////////////////////////////////////////////////////
        }


        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////

        // Could also have done these all with C# properties...
        public int getAtomicNumber()
        {
            return m_atomicNumber;
        }

        public string getName()
        {
            return m_name;
        }
        public void setName(string name)
        {
            m_name = name;
        }

        public string getSymbol()
        {
            return m_symbol;
        }
        public void setSymbol(string sym)
        {
            m_symbol = sym;
        }

        public double getWeight()
        {
            return m_weight;
        }
        public void setWeight(double weight)
        {
            m_weight = weight;
        }
#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////

        ///////////////////////////////////////////////////////////////////////
#if STUDENT_VERSION////////////////////////////////////////////////////////////
        // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

        public int getAtomicNumber()
        {
            // STUDENTS - IMPLEMENT THIS!!
            return 0;
        }

        public double getWeight()
        {
            // STUDENTS - IMPLEMENT THIS!!
            return 0;
        }
        public void setWeight(double weight)
        {
            // STUDENTS: IMPLEMENT THIS!!
        }

        // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
#endif  ///////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////
    }
}