using System;
using System.Text;
using Microsoft.Xna.Framework;

///////////////////////////////////////////////////////////////////
// STUDENTS: YOU NEED TO WRITE FILL IN THE Fireworks CLASS 
//           WITH YOUR OWN CODE, BELOW
///////////////////////////////////////////////////////////////////

namespace BurstABubble_Program
{
    /*
    // STUDENT VERSION STARTS HERE:
    class Fireworks : Projectile
    {
        // If you haven't done so already, you should read the README.txt
        // file, first


        /// <summary>
        /// 
        /// </summary>
        /// <returns>True, or false.  You need to understand what these values mean,
        /// before you'll be able to write this code well.  You should
        /// examine other code in the project for examples of 
        /// (A) under what circumstances other, similar classes return true/false
        /// (B) How the return value gets used (this second may be trickier to 
        /// understand on your own, but it's good experience to try to figure this
        /// aspect out, too)
        /// </returns>
        override public bool DoObjectUpdate()
        {
            return false;
        }


        /// <summary>
        /// Initializes the Fireworks, based on the user's input
        /// You shouldn't need to change this, in order to accomplish the assignment
        /// </summary>
        override public void GetUserInitInfo(Vector2 initV)
        {
            m_Speed = initV * 1.1f;  // speed;
        }

        /// <summary>
        /// This returns a string, which is used to figure out which 
        /// picture (aka 'texture') the fireworks should be used to draw
        /// the Fireworks object on the screen.
        /// You shouldn't need to change this, in order to accomplish the assignment
        /// </summary>
        override protected String GetTexture()
        {
            return @"explosion";
        }
    }
    // STUDENT VERSION ENDS HERE: */
    
    
    // INSTRUCTOR VERSION (EXAMPLE SOLUTION) STARTS HERE:
    class Fireworks : Projectile
    {
        // If you haven't done so already, you should read the README.txt
        // file, first

        private int m_Timer;

        public Fireworks()
        {
            m_Timer = 100;   // 100 cycles later, will explode
        }
        override public bool DoObjectUpdate()
        {
            if (m_Timer <= 10)
            {
                Radius = 10; //  1 + (10 - m_Timer);
            }
            else
                base.DoObjectUpdate();

            m_Timer--;
            return (m_Timer < 0);
        }

        override public void GetUserInitInfo(Vector2 initV)
        {
            m_Speed = initV * 1.1f;  // speed;
        }

        override protected String GetTexture()
        {
            return @"explosion";
        }
    }
    // INSTRUCTOR VERSION (EXAMPLE SOLUTION) ENDS HERE:
    
    
}
///////////////////////////////////////////////////////////////////
// STUDENTS: YOU NEED TO WRITE FILL IN THE Fireworks CLASS 
//           WITH YOUR OWN CODE, ABOVE
///////////////////////////////////////////////////////////////////