using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using XNACS1Lib;
using ListOfToysBase;

namespace CatchToyGame_Program
{
    // NOTE: IN ORDER FOR THIS PROGRAM TO WORK CORRECTLY, YOU NEED
    // TO HAVE YOUR ListOfToys CLASS INHERIT FROM CListOfToysBase
    //  (The IterateAndCompute method is defined on that base class)
    class ListOfToys : CListOfToysBase
    {
        // NOTE: IN ORDER FOR THIS PROGRAM TO WORK CORRECTLY, YOU NEED
        // TO HAVE YOUR ListNode CLASS IMPLEMENT IListOfToysNode
        private class ListNode  : IListOfToysNode
        {
            public ListNode m_Next;
            public IListOfToysNode Next
            {
                get
                {
                    return m_Next;
                }
            }

            public ToyObject m_Object;
            public float GetNodeSize 
            {
                get
                {
                      return m_Object.GetToySize; 
                }
            }

            public void SetNodePosition(float x, float y)
            { 
                  m_Object.SetToyPosition(x, y); 
            }

            public ListNode(ToyDropSpeed p)
            {
                m_Object = new ToyObject(p);
                m_Next = null;
            }
        }

        // NOTE: IN ORDER FOR THIS PROGRAM TO WORK CORRECTLY, YOU NEED
        // TO HAVE YOUR ListOfToys CLASS IMPLEMENT GetNextNode
        //  (The IterateAndCompute method uses the IListOfToysNode to
        //  iterate through all the items in the list, by using the
        //  GetNextNode method to go through the list, and the GetToy property
        //  to get the ToyObject that this node keeps track of.)
        // The list should store the oldest, high-speed item first,
        // then the second-oldest, high-speed item, etc, etc
        // Then the oldest low-speed item, second oldest high-speed item, etc, etc
        //
        // This method is here in case you don't want to have a single, long list
        //  of all the Toys, for whatever reason.
        protected override IListOfToysNode GetNextNode(IListOfToysNode current)
        {
            if (current != null)
                return current.Next;
            else
                return null;
        }

        // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:



        // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:

        public ListOfToys()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:



            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public void AddToy(ToyDropSpeed s)
        {
            ListNode newNode = new ListNode(s);

            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
            
            // Don't forget to call this, at the end!
            // base.IterateAndCompute(XNACS1Base.World.WorldMax.Y, TotalNumberOfNodes, ReferenceToFirstNode);
        }

        public ToyObject RemoveNextToy()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return null;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public bool isEmpty()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:

            return false;

            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
        }

        public void CurrentToyCount()
        {
            // STUDENTS: YOU NEED TO WRITE YOUR CODE BELOW:


            // STUDENTS: YOU NEED TO WRITE YOUR CODE ABOVE:
            XNACS1Base.EchoToBottomStatus(@"YOU NEED TO PUT THE NUMBER OF TOOLS, AND ANIMALS, HERE");
        }
    }
}