using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

#region ___CODE_ADDEDE____ 
using XNACS1Lib;
#endregion

namespace SimpleXNA
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : XNACS1Base
    {
        #region A Position user can control
        XNACS1Circle m_Pt;    // A pointer
        #endregion 

        protected override void InitializeWorld()
        {
            #region World Coordinate and initialize the ball
            World.SetWorldCoordinate(new Vector2(0f, 0f), 30f);      // Define the world coordinate
            m_Pt = new XNACS1Circle(new Vector2(5f, 2f), 1f);  // A simple circle for user control
            #endregion
        }

        protected override void UpdateWorld()
        {
            // Allows the game to exit
            if (GamePad.ButtonBackClicked())
                this.Exit();

            #region Manipluate the pointer
            m_Pt.Center += GamePad.ThumbSticks.Left;
            #endregion 
            EchoToTopStatus("Left-ThumbStick or i-j-m-k to contorl the ball");
        }
    }
}