using System;

namespace MonteCarloSolution
{
    class Program
    {
        // This is a pattern that one can use to avoid spending a lot of time
        // on OOP, despite using C# (or Java): the students are taught
        // that your 'main' class (containing the Main method) creates
        // an instance of the 'real' program class, and then
        // calls a method like RunProgram (or whatever) on that object.
        // It neatly side-steps confusing things like instantiating an instance
        // of the Program class, as well as confusing and goofy things like
        // covering the 'static' keyword in week one :)
        static void Main(string[] args)
        {
            MonteCarloIntegrator mci = new MonteCarloIntegrator();
            mci.RunProgram();
        }
    }
}
