using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

// Our own library
using XNACS1Lib;

namespace Othello_Guide_Program
{
    class PlayBoard
    {
        private int m_Resolution;
        private const float SIZE = 0.95f;
    
        public PlayBoard(int res)
        {
            m_Resolution = res;

            Vector2 pos = new Vector2();
            for (int i = 0; i < m_Resolution; i++)
            {
                pos.X = i + 0.5f;
                for (int j = 0; j < m_Resolution; j++)
                {
                    pos.Y = j + 0.5f;
                    XNACS1Rectangle cell = new XNACS1Rectangle(pos, SIZE, SIZE);
                    cell.OutsideColor = cell.CenterColor = Color.LightSeaGreen;
                }
            }
        }
    }
}

