// #define STUDENT_VERSION
#define INSTRUCTOR_VERSION

using System;
using System.Text;

namespace StarterProject
{
	public class Fireworks : Projectile
	{

        override public void GetUserInitInfo()
        {
            m_xSpeed = MenuCUI.GetValidUserInput("Initial X speed? (1-10)", 1, 11);
            m_ySpeed = MenuCUI.GetValidUserInput("Initial Y speed? (1-10)", 1, 11);

        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////
            m_roundsLeft = MenuCUI.GetValidUserInput("Rounds till the fireworks explodes? (1-5)", 1, 6) + 1;
            // NOTENOTE: The +1 is because it immediately gets decremented in the very first update.
            // Having the Firework lose a round immediately (before it's been printed out even once)
            // looks weird, but is (arguably) more correct.  The + 1 is mostly a asthetic thing,
            // though - students probably shouldn't be required to put that in.
#endif  ///////////////////////////////////////////////////////////////////////
            // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////

        }

        ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE CODE BELOW, STARTING HERE     //
#if INSTRUCTOR_VERSION/////////////////////////////////////////////////////////

        // Pretty much this entire file is the solution.  There was almost nothing
        // here before, and now there's a bunch of stuff.
        //
        protected int m_roundsLeft; // till detonation

        override public bool DoUpdate()
        {
            m_roundsLeft--;

            if(m_roundsLeft == -1)
            {
                return true;
            }

            if(m_roundsLeft == 0)
            {
                m_radius = 20;
                // This result will be printed out below, in the
                // print method
            }

            return base.DoUpdate();
        }

        override public void Print()
        {
            Console.WriteLine("Fireworks");
            base.Print();
            if (m_roundsLeft >= 0)
            {
                if (m_roundsLeft == 0)
                    Console.WriteLine("The fireworks has exploded!  (Note the increased radius)");
                else
                    Console.WriteLine("Rounds left until detonation: {0}", m_roundsLeft);
            }
        }
#endif  ///////////////////////////////////////////////////////////////////////
        // FOR STUDENT STARTER PROJECT: REMOVE ABOVE CODE, ENDING HERE       //
        ///////////////////////////////////////////////////////////////////////
    }
}
