using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

// Our own library
using XNACS1Lib;

namespace AlphabetHunt
{
    public class CScoreSystem
    {
        private int m_Score;
        private List<Char> m_InsertionOrder;

        private String m_Status;

        public CScoreSystem()
        {
            ResetScores();
            m_Status = null;
         }

        public void ResetScores()
        {   m_Score = 0;
            m_Status = "All scores reset";
            m_InsertionOrder = new List<char>();

        }

        public void ClearStatus() { m_Status = null; }
        public String GetStatus() { return m_Status; }

        public int GetScore() { return m_Score; }

        public void ScoreByNew(char c) {
            if (null == m_Status)
                m_Status = @"";

            m_InsertionOrder.Add(c);
            m_Status += " Got(" + c + ")";
            m_Score += c;
        }

        public List<char> InsertionOrder { get { return m_InsertionOrder; }}
    }
}
